import { system, world } from "@minecraft/server";

//Loop Events

let time = 0;

world.events.tick.subscribe(() =>{
    let w = world.getDimension("overworld");
    

    for (let p of world.getPlayers()) {
        let container = p.getComponent("inventory").container;
    let hand = container.getItem(p.selectedSlot);
        p.runCommandAsync(`function glowstone_bow`)
        if (!p.hasTag("glowstone_bow")) {
          p.runCommandAsync(`function no_light`);
      }
      if (p.hasTag("glowstone_bow")) {
         p.runCommandAsync(`function light`);
     }


     if(p.hasComponent("health").current == 0){
        p.runCommandAsync(`scoreboard players set @s using 0`);
        time = 0;
        p.removeTag("using");
        p.removeTag("diamond");
        p.removeTag("gold");
        p.removeTag("iron");
        p.removeTag("stone");;
        p.removeTag("wither");
        p.removeTag("tnt");
        p.removeTag("ender");
        p.removeTag("blaze");
        p.removeTag("health");
        p.removeTag("ice");
        p.removeTag("knockback");
        p.removeTag("spider");
        p.removeTag("magnet");
        p.removeTag("slime");
        p.removeTag("sponge");
        p.removeTag("glowstone");
        p.removeTag("lapis");
        p.removeTag("redstone");
        p.removeTag("mini");
        p.removeTag("shulker");
        p.removeTag("thunder");
        p.removeTag("long");
        p.removeTag("miner");
    }
    p.runCommandAsync(`function arrow`)
    p.runCommandAsync(`function gamerule`)
    if(p.hasTag("using")){
        if(p.hasTag("blaze") && hand.typeId == "new:blaze_bow"){
            time++;
        }
        if(p.hasTag("diamond") && hand.typeId == "new:diamond_bow"){
            time++;
        }
        if(p.hasTag("gold") && hand.typeId == "new:gold_bow"){
            time++;
        }
        if(p.hasTag("ender") && hand.typeId == "new:ender_bow"){
            time++;
        }
        if(p.hasTag("tnt") && hand.typeId == "new:explosive_bow"){
            time++;
        }
        if(p.hasTag("glowstone") && hand.typeId == "new:glowstone_bow"){
            time++;
        }
        if(p.hasTag("health") && hand.typeId == "new:health_bow"){
            time++;
        }
        if(p.hasTag("ice") && hand.typeId == "new:ice_bow"){
            time++;
        }
        if(p.hasTag("iron") && hand.typeId == "new:iron_bow"){
            time++;
        }
        if(p.hasTag("knockback") && hand.typeId == "new:knockback_bow"){
            time++;
        }
        if(p.hasTag("lapis") && hand.typeId == "new:lapis_bow"){
            time++;
        }
        if(p.hasTag("long") && hand.typeId == "new:long_bow"){
            time++;
        }
        if(p.hasTag("magnet") && hand.typeId == "new:magnet_bow"){
            time++;
        }
        if(p.hasTag("miner") && hand.typeId == "new:miner_bow"){
            time++;
        }
        if(p.hasTag("mini") && hand.typeId == "new:mini_bow"){
            time++;
        }
        if(p.hasTag("redstone") && hand.typeId == "new:redstone_bow"){
            time++;
        }
        if(p.hasTag("shulker") && hand.typeId == "new:shulker_bow"){
            time++;
        }
        if(p.hasTag("slime") && hand.typeId == "new:slime_bow"){
            time++;
        }
        if(p.hasTag("spider") && hand.typeId == "new:spider_bow"){
            time++;
        }
        if(p.hasTag("sponge") && hand.typeId == "new:sponge_bow"){
            time++;
        }
        if(p.hasTag("stone") && hand.typeId == "new:stone_bow"){
            time++;
        }
        if(p.hasTag("thunder") && hand.typeId == "new:thunder_bow"){
            time++;
        }
        if(p.hasTag("wither") && hand.typeId == "new:smoke_bow"){
            time++;
        }


        if(time >= 1 && time < 5){
          p.runCommandAsync(`scoreboard players set @s using 1`);
        }
        if(time >= 5 && time < 10){
           p.runCommandAsync(`scoreboard players set @s using 2`);
        }
        if(time >= 10){
           p.runCommandAsync(`scoreboard players set @s using 3`);
       }
    }
    }
});

world.events.itemStartCharge.subscribe((use) =>{
    let p = use.source;
    let bow = "_bow";
    let item = use.itemStack.typeId;
    if(item.toLowerCase().includes(bow)){
        p.addTag("using");
    }
});

world.events.itemStopCharge.subscribe((stop) =>{
    let p = stop.source;
    let bow = "_bow";
    let item = stop.itemStack.typeId;
    if(item.toLowerCase().includes(bow)){
        p.removeTag("using");
        p.runCommandAsync(`scoreboard players set @s using 0`);
        time = 0;
    }

})

world.events.blockPlace.subscribe((blockPlace) =>{
 let block = blockPlace.block;
 let player = blockPlace.player;

 let blockLocation = [
    blockPlace.block.location.x,
    blockPlace.block.location.y,
    blockPlace.block.location.z

    ];

 if(block.typeId == "minecraft:fletching_table"){
     player.runCommandAsync(`setblock ${blockLocation[0]} ${blockLocation[1]} ${blockLocation[2]} new:bow_table 0`)
 }

});